/* Casio FZ-1 data structure definitions */

#define NLOOPS 8

struct voicedata
{
	long	wave_start_address;
	long	wave_end_address;
	long	generator_start_address;
	long	generator_end_address;

	short	loop_style;
	BYTE	sustain_loop_number;
	BYTE	multi_loop_end_number;
	long	loop_start_addresses[NLOOPS];

	long	loop_end_addresses[NLOOPS];

	short	loop_cross_feed_time[NLOOPS];
	unsigned short loop_time[NLOOPS];

	short	voice_pitch;	/* voice pitch with detune */
	BYTE	frequency_offset;
	BYTE	filter_Q_offset;

	BYTE	dca_envelope_sustain_point;
	BYTE	dca_envelope_end_point;
	BYTE	dca_envelope_rate_values[NLOOPS];
	UBYTE	dca_envelope_stop_values[NLOOPS];

	BYTE	dcf_envelope_sustain_point;
	BYTE	dcf_envelope_end_point;
	BYTE	dcf_rate_envelope_rate_values[NLOOPS];
	UBYTE	dcf_envelope_stop_values[NLOOPS];

	unsigned short lfo_delay_time;
	UBYTE	lfo_waveform;
	UBYTE	lfo_attack_value;
	BYTE	lfo_rate;
	BYTE	lfo_pitch_depth;
	BYTE	lfo_amplitude_depth;
	BYTE	lfo_filter_depth;
	BYTE	lfo_filter_Q_depth;
	BYTE	initial_touch_Q_follow;

	BYTE	dca_keyboard_follow_depth;
	BYTE	dca_noterate_scaling_depth;
	BYTE	dcf_keyboard_follow_depth;
	BYTE	dcf_noterate_scaling_depth;

	BYTE	initial_touch_dca_key_follow;
	BYTE	initial_touch_dca_rate_scaling;
	BYTE	initial_touch_dcf_key_follow;
	BYTE	initial_touch_dca_rate_scaling;

	UBYTE	high_width_MIDI_code;	
	UBYTE	low_width_MIDI_code;
	UBYTE	keynote_center;

	UBYTE	sampling_frequency_index;

	char	name[14];
}


